/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityMembershipCheck type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityMembershipCheck{}

// IdentityMembershipCheck struct for IdentityMembershipCheck
type IdentityMembershipCheck struct {
	IsMember        *bool          `json:"isMember,omitempty"`
	GroupIdentifier NullableString `json:"groupIdentifier,omitempty"`
	Upn             NullableString `json:"upn,omitempty"`
}

// NewIdentityMembershipCheck instantiates a new IdentityMembershipCheck object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityMembershipCheck() *IdentityMembershipCheck {
	this := IdentityMembershipCheck{}
	return &this
}

// NewIdentityMembershipCheckWithDefaults instantiates a new IdentityMembershipCheck object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityMembershipCheckWithDefaults() *IdentityMembershipCheck {
	this := IdentityMembershipCheck{}
	return &this
}

// GetIsMember returns the IsMember field value if set, zero value otherwise.
func (o *IdentityMembershipCheck) GetIsMember() bool {
	if o == nil || IsNil(o.IsMember) {
		var ret bool
		return ret
	}
	return *o.IsMember
}

// GetIsMemberOk returns a tuple with the IsMember field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembershipCheck) GetIsMemberOk() (*bool, bool) {
	if o == nil || IsNil(o.IsMember) {
		return nil, false
	}
	return o.IsMember, true
}

// HasIsMember returns a boolean if a field has been set.
func (o *IdentityMembershipCheck) HasIsMember() bool {
	if o != nil && !IsNil(o.IsMember) {
		return true
	}

	return false
}

// SetIsMember gets a reference to the given bool and assigns it to the IsMember field.
func (o *IdentityMembershipCheck) SetIsMember(v bool) {
	o.IsMember = &v
}

// GetGroupIdentifier returns the GroupIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipCheck) GetGroupIdentifier() string {
	if o == nil || IsNil(o.GroupIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.GroupIdentifier.Get()
}

// GetGroupIdentifierOk returns a tuple with the GroupIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipCheck) GetGroupIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupIdentifier.Get(), o.GroupIdentifier.IsSet()
}

// HasGroupIdentifier returns a boolean if a field has been set.
func (o *IdentityMembershipCheck) HasGroupIdentifier() bool {
	if o != nil && o.GroupIdentifier.IsSet() {
		return true
	}

	return false
}

// SetGroupIdentifier gets a reference to the given NullableString and assigns it to the GroupIdentifier field.
func (o *IdentityMembershipCheck) SetGroupIdentifier(v string) {
	o.GroupIdentifier.Set(&v)
}

// SetGroupIdentifierNil sets the value for GroupIdentifier to be an explicit nil
func (o *IdentityMembershipCheck) SetGroupIdentifierNil() {
	o.GroupIdentifier.Set(nil)
}

// UnsetGroupIdentifier ensures that no value is present for GroupIdentifier, not even an explicit nil
func (o *IdentityMembershipCheck) UnsetGroupIdentifier() {
	o.GroupIdentifier.Unset()
}

// GetUpn returns the Upn field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipCheck) GetUpn() string {
	if o == nil || IsNil(o.Upn.Get()) {
		var ret string
		return ret
	}
	return *o.Upn.Get()
}

// GetUpnOk returns a tuple with the Upn field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipCheck) GetUpnOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Upn.Get(), o.Upn.IsSet()
}

// HasUpn returns a boolean if a field has been set.
func (o *IdentityMembershipCheck) HasUpn() bool {
	if o != nil && o.Upn.IsSet() {
		return true
	}

	return false
}

// SetUpn gets a reference to the given NullableString and assigns it to the Upn field.
func (o *IdentityMembershipCheck) SetUpn(v string) {
	o.Upn.Set(&v)
}

// SetUpnNil sets the value for Upn to be an explicit nil
func (o *IdentityMembershipCheck) SetUpnNil() {
	o.Upn.Set(nil)
}

// UnsetUpn ensures that no value is present for Upn, not even an explicit nil
func (o *IdentityMembershipCheck) UnsetUpn() {
	o.Upn.Unset()
}

func (o IdentityMembershipCheck) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityMembershipCheck) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.IsMember) {
		toSerialize["isMember"] = o.IsMember
	}
	if o.GroupIdentifier.IsSet() {
		toSerialize["groupIdentifier"] = o.GroupIdentifier.Get()
	}
	if o.Upn.IsSet() {
		toSerialize["upn"] = o.Upn.Get()
	}
	return toSerialize, nil
}

type NullableIdentityMembershipCheck struct {
	value *IdentityMembershipCheck
	isSet bool
}

func (v NullableIdentityMembershipCheck) Get() *IdentityMembershipCheck {
	return v.value
}

func (v *NullableIdentityMembershipCheck) Set(val *IdentityMembershipCheck) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityMembershipCheck) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityMembershipCheck) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityMembershipCheck(val *IdentityMembershipCheck) *NullableIdentityMembershipCheck {
	return &NullableIdentityMembershipCheck{value: val, isSet: true}
}

func (v NullableIdentityMembershipCheck) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityMembershipCheck) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
